# Detect the distribution in use
%global __despace head -n 1 | tr -d '[:space:]' | sed -e 's/[(].*[)]//g'
%global __lower4 cut -c 1-4 | tr '[:upper:]' '[:lower:]'
%global __distfile %([ -f /etc/SuSE-release ] && echo /etc/SuSE-release || echo /etc/redhat-release)
%global __distinit %(sed -e 's/ release .*//' -e 's/\\([A-Za-z]\\)[^ ]*/\\1/g' %{__distfile} | %{__despace} | %{__lower4})
%global __distvers %(sed -e 's/.* release \\([^. ]*\\).*/\\1/' %{__distfile} | %{__despace})
# Identify Alma, CentOS, CentOS Stream and Rocky Linux as rhel
%if "%{__distinit}" == "a" || "%{__distinit}" == "c" || "%{__distinit}" == "cl" || "%{__distinit}" == "cs" || "%{__distinit}" == "rl"
%global __distinit rhel
%endif
# Dist tag for Fedora is still "fc"
%if "%{__distinit}" == "f"
%global __distinit fc
%endif

# Weak deps available in rpm ≥ 4.12
%global have_weak_deps 0%{?fedora} > 20 || 0%{?rhel} > 7

Name:		perl-Test-CleanNamespaces
Summary:	Check for uncleaned imports
Version:	0.24
Release:	19.%{__distinit}%{__distvers}
License:	GPL-1.0-or-later OR Artistic-1.0-Perl
URL:		https://metacpan.org/release/Test-CleanNamespaces
Source0:	https://cpan.metacpan.org/modules/by-module/Test/Test-CleanNamespaces-%{version}.tar.gz
BuildArch:	noarch
# Module Build
BuildRequires:	coreutils
BuildRequires:	findutils
BuildRequires:	make
BuildRequires:	perl-generators
BuildRequires:	perl-interpreter
BuildRequires:	perl(CPAN::Meta::Requirements) >= 2.120620
BuildRequires:	perl(ExtUtils::MakeMaker)
BuildRequires:	perl(Module::Metadata)
# Module
BuildRequires:	perl(Exporter) >= 5.57
BuildRequires:	perl(File::Find)
BuildRequires:	perl(File::Spec)
BuildRequires:	perl(Module::Runtime)
BuildRequires:	perl(Package::Stash) >= 0.14
BuildRequires:	perl(Package::Stash::XS)
BuildRequires:	perl(strict)
BuildRequires:	perl(Sub::Identify)
BuildRequires:	perl(Test::Builder)
BuildRequires:	perl(warnings)
# Optional Runtime
BuildRequires:	perl(Role::Tiny) >= 1.003000
# Test Suite
BuildRequires:	perl(constant)
BuildRequires:	perl(CPAN::Meta) >= 2.120900
BuildRequires:	perl(CPAN::Meta::Prereqs)
BuildRequires:	perl(File::pushd)
BuildRequires:	perl(File::Spec::Functions)
BuildRequires:	perl(if)
BuildRequires:	perl(lib)
BuildRequires:	perl(Module::Runtime)
BuildRequires:	perl(namespace::clean)
BuildRequires:	perl(overload)
BuildRequires:	perl(parent)
BuildRequires:	perl(Scalar::Util)
BuildRequires:	perl(Sub::Exporter)
BuildRequires:	perl(Test::Deep)
BuildRequires:	perl(Test::More) >= 0.96
BuildRequires:	perl(Test::Needs)
BuildRequires:	perl(Test::Tester)
BuildRequires:	perl(Test::Warnings) >= 0.009
# Optional Test Requirements
%if 0%{!?perl_bootstrap:1}
BuildRequires:	perl(Class::MOP::Class)
BuildRequires:	perl(metaclass)
BuildRequires:	perl(Moo) >= 1.000007
BuildRequires:	perl(Moo::Role)
BuildRequires:	perl(Moose)
BuildRequires:	perl(Moose::Exporter)
BuildRequires:	perl(Moose::Role)
BuildRequires:	perl(MooseX::Role::Parameterized)
BuildRequires:	perl(Mouse)
BuildRequires:	perl(Mouse::Role)
%endif
# Dependencies
%if 0%{?fedora} < 38 && 0%{?rhel} < 10
Requires:	perl(:MODULE_COMPAT_%(eval "`perl -V:version`"; echo $version))
%endif
%if %{have_weak_deps}
Recommends:	perl(Role::Tiny) >= 1.003000
%else
Requires:	perl(Role::Tiny) >= 1.003000
%endif

%description
This module lets you check your module's namespaces for imported functions you
might have forgotten to remove with namespace::autoclean or namespace::clean
and are therefore available to be called as methods, which usually isn't want
you want.

%prep
%setup -q -n Test-CleanNamespaces-%{version}

%build
perl Makefile.PL INSTALLDIRS=vendor
make %{?_smp_mflags}

%install
make pure_install DESTDIR=%{buildroot}
find %{buildroot} -type f -name .packlist -delete
%{_fixperms} -c %{buildroot}

%check
make test %{!?perl_bootstrap:AUTOMATED_TESTING=1}

%files
%license LICENCE
%doc Changes CONTRIBUTING README
%{perl_vendorlib}/Test/
%{_mandir}/man3/Test::CleanNamespaces.3*

%changelog
* Sun May 14 2023 Paul Howarth <paul@city-fan.org> - 0.24-19
- Use SPDX-format license tag
- Weaken dependency on Role::Tiny where possible
- Use %%license unconditionally

* Sun Jun  9 2019 Paul Howarth <paul@city-fan.org> - 0.24-4
- Perl 5.30 rebuild

* Mon Dec 10 2018 Paul Howarth <paul@city-fan.org> - 0.24-1
- Update to 0.24
  - Fix detection of constant subs on some platforms

* Fri Jun 29 2018 Paul Howarth <paul@city-fan.org> - 0.23-2
- Perl 5.28 rebuild

* Tue Jun 26 2018 Paul Howarth <paul@city-fan.org> - 0.23-1
- Update to 0.23
  - Properly skip potentially-problematic tests when needed, due to circular
    dependencies between Moose and Test::CleanNamespaces (CPAN RT#125678)

* Wed Apr 11 2018 Paul Howarth <paul@city-fan.org> - 0.22-6
- BR: perl-generators unconditionally
- BR: perl-interpreter rather than perl
- Drop support for EOL distributions prior to F-13
  - Drop BuildRoot: and Group: tags
  - Drop explicit buildroot cleaning in %%install section
  - Drop explicit %%clean section
  - Drop workaround for building with Test::More < 0.94

* Mon Jan  9 2017 Paul Howarth <paul@city-fan.org> - 0.22-2
- Test::Warnings now available from Fedora 9 onwards

* Fri Aug 19 2016 Paul Howarth <paul@city-fan.org> - 0.22-1
- Update to 0.22
  - Properly find the list of modules to test (regression since 0.19)
- Bundle Test::Warnings as well as Test::More for tests on old distributions

* Tue Aug 16 2016 Paul Howarth <paul@city-fan.org> - 0.21-1
- Update to 0.21
  - Switch to plain old Exporter, removing build_* subs from the API

* Fri Jun 17 2016 Paul Howarth <paul@city-fan.org> - 0.19-1
- Update to 0.19
  - Removed dependencies on namespace::clean, Sub::Exporter, File::Find::Rule

* Tue May 17 2016 Paul Howarth <paul@city-fan.org> - 0.18-6
- Test::Warnings needed for bootstrapping
- BR: perl-generators where possible
- Simplify find command using -delete

* Wed Jan 21 2015 Paul Howarth <paul@city-fan.org> - 0.18-1
- Update to 0.18
  - Remove Moose test requires <-> Test::CleanNamespaces test recommends
    circular relationship (softened to suggests)

* Tue Jan 20 2015 Paul Howarth <paul@city-fan.org> - 0.17-1
- Update to 0.17
  - Skip Mouse tests if some required interfaces are not available

* Thu Sep  4 2014 Paul Howarth <paul@city-fan.org> - 0.16-1
- Update to 0.16
  - Bump Package::Stash prereq to ensure used methods are available
  - Skip Moose-related tests for normal installs, to get out of circularity
    hell if Moose is installed but broken and needing an upgrade

* Wed Aug 27 2014 Paul Howarth <paul@city-fan.org> - 0.14-2
- Don't run the optional tests when bootstrapping, to avoid circular build
  dependencies
- perl(Test::Warnings) is required when bootstrapping

* Thu Aug 14 2014 Paul Howarth <paul@city-fan.org> - 0.14-1
- Update to 0.14
  - Remove accidental dependency on Class::MOP (which turned into a circular
    dependency with Moose-2.1211)
- Use %%license where possible

* Wed Jun 25 2014 Paul Howarth <paul@city-fan.org> - 0.13-1
- Update to 0.13
  - Bump (optional) prereq on Moo to get some fixes for handling roles
- Edit out use of Test::Warnings in the test suite for old distributions that
  can't provide it

* Wed Jun 18 2014 Paul Howarth <paul@city-fan.org> - 0.12-1
- Update to 0.12
  - Also special case constant subs, which show up in the symbol table before
    perl 5.010 as 'constant::__ANON__'

* Tue Jun 17 2014 Paul Howarth <paul@city-fan.org> - 0.11-2
- Add upstream fix for Perl 5.8 compatibility

* Mon Jun 16 2014 Paul Howarth <paul@city-fan.org> - 0.11-1
- Update to 0.11
  - Increased version for optional Role::Tiny prereq, to get the needed is_role
    interface
  - Now ignoring 'import', 'unimport' subs; also handle users of
    Moose::Exporter without erroring
  - Now ignoring overloaded methods
  - Now also properly handle classes using Class::MOP directly
  - Fix test diagnostics in the success case
  - Fix use of a new Scalar::Util export in tests
  - The return value of namespaces_clean() and all_namespaces_clean() is now
    consistent with the result of the test(s)
  - Fixed tests to expose an issue with Mouse classes, and documented this
    (now) known issue
- Switch to ExtUtils::MakeMaker flow
- Test suite now relies on perl 5.10 or later, so don't build for anything
  older
- Drop %%defattr, redundant since rpm 4.4
- BR: perl(Test::Requires) unconditionally

* Sun Mar  9 2014 Paul Howarth <paul@city-fan.org> - 0.08-1
- Update to 0.08
  - Fixed method identification in Moose and Mouse roles
- Update patch for building without Test::Requires

* Mon Mar  3 2014 Paul Howarth <paul@city-fan.org> - 0.07-1
- Update to 0.07
  - Lots more tests
  - In failing tests, identify the source of the uncleaned sub(s)
  - Remove the dependency on Class::MOP by inspecting the package stash
    directly
- Switch to Module::Build::Tiny flow
- Package upstream's new CONTRIBUTING and README.md files
- Don't bother trying to run the extra tests
- Test suite actually requires Test::More ≥ 0.94, so bundle a suitable
  version to use if necessary
- Drop all existing patches
- Add a patch to support building with old Module::Build::Tiny versions
- Add a patch to support building without Test::Requires if necessary

* Wed Sep 25 2013 Paul Howarth <paul@city-fan.org> - 0.05-1
- Update to 0.05
  - Re-release with fixed compile test
- Update patches as needed

* Thu Sep 19 2013 Paul Howarth <paul@city-fan.org> - 0.04-2
- Don't run the extra tests when bootstrapping

* Sun Sep 15 2013 Paul Howarth <paul@city-fan.org> - 0.04-1
- Update to 0.04
  - Remove use of deprecated Class::MOP::load_class
- This release by ETHER -> update source URL
- Add patches to support building with old Test::More versions
- Add buildreqs for and explicitly run the extra tests

* Thu Jul 25 2013 Paul Howarth <paul@city-fan.org> - 0.03-2
- Perl 5.18 rebuild

* Sat Jun 29 2013 Paul Howarth <paul@city-fan.org> - 0.03-1
- Initial RPM version
